// ----------------------------------------------------------------------------
// $Id: CheckedVariable.java,v 1.1 1999/06/29 12:46:40 schreine Exp $
// a pair of a variable and a name (denoting a predicate)
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class CheckedVariable implements ConstrainedVariable
{
  private String string;
  private String pred;

  public CheckedVariable(String _string, String _pred)
  {
    string = _string;
    pred = _pred;
  }

  public String name()
  {
    return string;
  }

  // --------------------------------------------------------------------------
  // throws exception if value does not match variable constraints
  // --------------------------------------------------------------------------
  public void check(Value value) throws EvalException
  {
    if (pred == null) return;
    Predicate p = Model.getPredicate(pred, 1);
    if (p == null)
      throw new EvalException("unknown predicate " + pred + "/1");
    Value[] argument = new Value[1];
    argument[0] = value;
    if (!p.apply(argument))
      throw new EvalException
	("value " + value.getString() + " does not satisfy predicate " +
	 pred + "/1 for parameter " + string);    
  }
}
// ----------------------------------------------------------------------------
// $Id: CheckedVariable.java,v 1.1 1999/06/29 12:46:40 schreine Exp $
// ----------------------------------------------------------------------------
