// ----------------------------------------------------------------------------
// $Id: Control.java,v 1.6 1999/07/12 08:32:11 schreine Exp $
// system control
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;
import java.io.*;

public final class Control
{
  private boolean applet;
  private Screen screen;
  private InputStream in;
  private PrintWriter writer;
  private boolean silent = false;

  public Control(boolean _applet, Screen _screen,
		 InputStream _in, OutputStream _out)
  {
    applet = _applet;
    screen = _screen;
    in = _in;
    writer = new PrintWriter(_out, true);
  }

  public boolean isApplet()
  {
    return applet;
  }

  public void setSilent(boolean _silent)
  {
    silent = _silent;
  }

  public boolean isSilent()
  {
    return silent;
  }

  public Screen getScreen()
  {
    return screen;
  }

  public InputStream getInputStream()
  {
    return in;
  }

  public void print(String message)
  {
    writer.print(message);
  }

  public void println(String message)
  {
    writer.println(message);
  }

  public void abort()
  {
    println("> execution is aborted.");
    System.exit(-1);
  }
}
// ----------------------------------------------------------------------------
// $Id: Control.java,v 1.6 1999/07/12 08:32:11 schreine Exp $
// ----------------------------------------------------------------------------



