// ----------------------------------------------------------------------------
// $Id: DummyFunction.java,v 1.1 1999/07/12 08:32:11 schreine Exp $
// a dummy function (cannot be applied)
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class DummyFunction implements Function
{
  private String string;
  private ConstrainedVariable[] params;

  // --------------------------------------------------------------------------
  // function 'name(params)'
  // --------------------------------------------------------------------------
  public DummyFunction(String _name, ConstrainedVariable[] _params)
  {
    string = _name;
    params = _params;
  }

  // --------------------------------------------------------------------------
  // the name of the function
  // --------------------------------------------------------------------------
  public String name()
  {
    return string;
  }

  // --------------------------------------------------------------------------
  // the number of function parameters
  // --------------------------------------------------------------------------
  public int arity()
  {
    return params.length;
  }

  // ------------------------------------------------------------------------
  // apply function to arguments
  // ------------------------------------------------------------------------
  public Value apply(Value[] arguments) throws EvalException
  {
    throw new EvalException("cannot apply dummy function "
			    + string + "/" + arity());
  }
}
// ----------------------------------------------------------------------------
// $Id: DummyFunction.java,v 1.1 1999/07/12 08:32:11 schreine Exp $
// ----------------------------------------------------------------------------
