// ----------------------------------------------------------------------------
// $Id: DummyPredicate.java,v 1.1 1999/07/12 08:32:11 schreine Exp $
// a dummy predicate (cannot be applied)
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class DummyPredicate implements Predicate
{
  private String string;
  private ConstrainedVariable[] params;

  // --------------------------------------------------------------------------
  // the predicate 'name(params) :<=> formula'
  // --------------------------------------------------------------------------
  public DummyPredicate(String _name, ConstrainedVariable[] _params)
  {
    string = _name;
    params = _params;
  }

  // --------------------------------------------------------------------------
  // the name of the predicate
  // --------------------------------------------------------------------------
  public String name()
  {
    return string;
  }

  // --------------------------------------------------------------------------
  // the number of predicate parameters
  // --------------------------------------------------------------------------
  public int arity()
  {
    return params.length;
  }

  // ------------------------------------------------------------------------
  // apply predicate to arguments
  // ------------------------------------------------------------------------
  public boolean apply(Value[] arguments) throws EvalException
  {
    throw new EvalException("cannot apply dummy predicate " 
			    + string + "/" + arity());
  }
}
// ----------------------------------------------------------------------------
// $Id: DummyPredicate.java,v 1.1 1999/07/12 08:32:11 schreine Exp $
// ----------------------------------------------------------------------------
