// ----------------------------------------------------------------------------
// $Id: Atomic.java,v 1.2 1999/06/28 13:49:10 schreine Exp $
// atomic formula
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class Atomic implements Formula
{
  private String name;
  private Term[] arguments;

  public Atomic(String _name, Term[] _arguments)
  {
    name = _name;
    arguments = _arguments;
  }

  public boolean eval() throws EvalException
  {
    Predicate predicate = Model.getPredicate(name, arguments.length);
    if (predicate == null)
      throw new EvalException("unknown predicate " + name + 
			      "/" + arguments.length);
    Value[] values = new Value[arguments.length];
    for (int i=0; i<values.length; i++)
      values[i] = arguments[i].eval();
    return predicate.apply(values);
  }  
}
// ----------------------------------------------------------------------------
// $Id: Atomic.java,v 1.2 1999/06/28 13:49:10 schreine Exp $
// ----------------------------------------------------------------------------
