// ----------------------------------------------------------------------------
// $Id: ExistsN.java,v 1.6 1999/07/12 12:17:36 schreine Exp $
// existential quantification with n variables
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class ExistsN implements Formula
{
  private IteratorVariable[] variables;
  private Formula formula;

  public ExistsN(IteratorVariable[] _variables, Formula _formula)
  {
    variables = _variables;
    formula = _formula;
  }

  private boolean eval(int i) throws EvalException
  {
    if (i == variables.length)
      return formula.eval();
    Iterator iterator = variables[i].iterator(); 
    while (iterator.hasNext())
    {
      Context.begin(variables[i].name(), iterator.next());
      boolean result = eval(i+1);
      Context.end();
      if (result) return true;
    }
    return false;
  }

  public boolean eval() throws EvalException
  {
    return eval(0);
  }
}
// ----------------------------------------------------------------------------
// $Id: ExistsN.java,v 1.6 1999/07/12 12:17:36 schreine Exp $
// ----------------------------------------------------------------------------
