// ----------------------------------------------------------------------------
// $Id: ForAll.java,v 1.4 1999/06/29 10:05:26 schreine Exp $
// universal quantification with one variable
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class ForAll implements Formula
{
  private String variable;
  private Term domain;
  private Formula formula;

  public ForAll(String _variable, Term _domain, Formula _formula)
  {
    variable = _variable;
    domain = _domain;
    formula = _formula;
  }

  public boolean eval() throws EvalException
  {
    Iterator iterator = Model.iterator(domain);
    while (iterator.hasNext())
    {
      Context.begin(variable, iterator.next());
      boolean result = formula.eval();
      Context.end();
      if (!result) return false;
    }
    return true;
  }
}
// ----------------------------------------------------------------------------
// $Id: ForAll.java,v 1.4 1999/06/29 10:05:26 schreine Exp $
// ----------------------------------------------------------------------------
