// ----------------------------------------------------------------------------
// $Id: IfThenElseFormula.java,v 1.2 1999/06/28 13:49:10 schreine Exp $
// two-way conditional formula
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class IfThenElseFormula implements Formula
{
  private Formula guard;
  private Formula formula0;
  private Formula formula1;

  public IfThenElseFormula(Formula _guard, 
			   Formula _formula0, Formula _formula1)
  {
    guard = _guard;
    formula0 = _formula0;
    formula1 = _formula1;
  }

  public boolean eval() throws EvalException
  {
    if (guard.eval())
      return formula0.eval();
    else
      return formula1.eval();
  }
}
// ----------------------------------------------------------------------------
// $Id: IfThenElseFormula.java,v 1.2 1999/06/28 13:49:10 schreine Exp $
// ----------------------------------------------------------------------------
