// ----------------------------------------------------------------------------
// $Id: IfThenFormula.java,v 1.3 1999/06/29 10:05:26 schreine Exp $
// one-way conditional formula
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class IfThenFormula implements Formula
{
  private Formula guard;
  private Formula formula;

  public IfThenFormula(Formula _guard, Formula _formula)
  {
    guard = _guard;
    formula = _formula;
  }

  public boolean eval() throws EvalException
  {
    if (Model.checkGuard() && !guard.eval())
      throw new EvalException("guard condition is false");
    return formula.eval();
  }
}
// ----------------------------------------------------------------------------
// $Id: IfThenFormula.java,v 1.3 1999/06/29 10:05:26 schreine Exp $
// ----------------------------------------------------------------------------
