// ----------------------------------------------------------------------------
// $Id: In.java,v 1.4 1999/06/29 10:05:26 schreine Exp $
// universal quantification with one variable
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class In implements Formula
{
  private Term term0;
  private Term term1;

  public In(Term _term0, Term _term1)
  {
    term0 = _term0;
    term1 = _term1;
  }

  public boolean eval() throws EvalException
  {
    Value v = term0.eval();
    Value d = term1.eval();
    if (!(d instanceof Domain))
      throw new EvalException
	("value " + d.getString() + " does not denote domain");
    return ((Domain)d).hasElement(v);
  }
}
// ----------------------------------------------------------------------------
// $Id: In.java,v 1.4 1999/06/29 10:05:26 schreine Exp $
// ----------------------------------------------------------------------------
