// ----------------------------------------------------------------------------
// $Id: LetFormula.java,v 1.2 1999/06/28 13:49:10 schreine Exp $
// formula with one local variable
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class LetFormula implements Formula
{
  private String variable;
  private Term term;
  private Formula formula;

  public LetFormula(String _variable, Term _term, Formula _formula)
  {
    variable = _variable;
    term = _term;
    formula = _formula;
  }

  public boolean eval() throws EvalException
  {
    Context.begin(variable, term.eval());
    boolean result = formula.eval();
    Context.end();
    return result;
  }  
}
// ----------------------------------------------------------------------------
// $Id: LetFormula.java,v 1.2 1999/06/28 13:49:10 schreine Exp $
// ----------------------------------------------------------------------------
