// ----------------------------------------------------------------------------
// $Id: LetNFormula.java,v 1.4 1999/06/29 12:46:40 schreine Exp $
// formula with n local variables
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Formulas;
import Logic.*;

public final class LetNFormula implements Formula
{
  private BoundVariable[] variables;
  private Formula formula;

  public LetNFormula(BoundVariable[] _variables, Formula _formula)
  {
    variables = _variables;
    formula = _formula;
  }

  public boolean eval() throws EvalException
  {
    for (int i=0; i<variables.length; i++)
      Context.begin(variables[i].name(), variables[i].value().eval());
    boolean result = formula.eval();
    for (int i=0; i<variables.length; i++)
      Context.end();
    return result;
  }  
}
// ----------------------------------------------------------------------------
// $Id: LetNFormula.java,v 1.4 1999/06/29 12:46:40 schreine Exp $
// ----------------------------------------------------------------------------
