// ----------------------------------------------------------------------------
// $Id: Join.java,v 1.1 1999/06/29 08:21:05 schreine Exp $
// join an element to a set
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Functions;
import Logic.*;

public final class Join implements Function
{
  public String name()
  {
    return "join";
  }

  public int arity()
  {
    return 2;
  }

  public Value apply(Value[] arguments) throws EvalException
  {
    if (!(arguments[1] instanceof Set))
      throw new EvalException
	("value " + arguments[1].getString() + " in function join/2 is not a set");
    Set set = ((Set)arguments[1]).duplicate();
    set.addElement(arguments[0]);
    return set;
  }
}
// ----------------------------------------------------------------------------
// $Id: Join.java,v 1.1 1999/06/29 08:21:05 schreine Exp $
// ----------------------------------------------------------------------------
