// ----------------------------------------------------------------------------
// $Id: Length.java,v 1.1 1999/06/29 08:21:05 schreine Exp $
// number of fields in a tuple
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Functions;
import Logic.*;

public final class Length implements Function
{
  public String name()
  {
    return "length";
  }

  public int arity()
  {
    return 1;
  }

  public Value apply(Value[] arguments) throws EvalException
  {
    if (!(arguments[0] instanceof Tuple))
      throw new EvalException
	("value " + arguments[0].getString() + " in length/1 is not a tuple");
    Tuple tuple = (Tuple)arguments[0];
    return new Nat(tuple.length());
  }
}
// ----------------------------------------------------------------------------
// $Id: Length.java,v 1.1 1999/06/29 08:21:05 schreine Exp $
// ----------------------------------------------------------------------------
