// ----------------------------------------------------------------------------
// $Id: Multiply.java,v 1.1 1999/06/29 08:21:05 schreine Exp $
// multiply two natural numbers
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Functions;
import Logic.*;

public final class Multiply implements Function
{
  public String name()
  {
    return "*";
  }

  public int arity()
  {
    return 2;
  }

  public void check(Value value) throws EvalException
  {
    if (!(value instanceof Nat))
      throw new EvalException
	("value " + value.getString() + " in function */2 is not a natural number");
  }

  public Value apply(Value[] arguments) throws EvalException
  {
    check(arguments[0]);
    check(arguments[1]);
    int n0 = ((Nat)arguments[0]).intValue();
    int n1 = ((Nat)arguments[1]).intValue();
    return new Nat(n0*n1);
  }
}
// ----------------------------------------------------------------------------
// $Id: Multiply.java,v 1.1 1999/06/29 08:21:05 schreine Exp $
// ----------------------------------------------------------------------------
