// ----------------------------------------------------------------------------
// $Id: NaturalsFun.java,v 1.3 1999/06/29 08:21:05 schreine Exp $
// constant denoting a subrange of the natural numbers
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Functions;
import Logic.*;

public final class NaturalsFun implements Function
{
  public String name()
  {
    return "nat";
  }

  public int arity()
  {
    return 2;
  }

  private void check(Value value) throws EvalException
  {
    if (!(value instanceof Nat))
      throw new EvalException
	("value " + value.getString() + " in nat/2 is not a natural number");
  }

  public Value apply(Value[] arguments) throws EvalException
  {
    check(arguments[0]);
    check(arguments[1]);    
    int from = ((Nat)arguments[0]).intValue();
    int to = ((Nat)arguments[1]).intValue();
    return new Naturals(from, to);
  }
}
// ----------------------------------------------------------------------------
// $Id: NaturalsFun.java,v 1.3 1999/06/29 08:21:05 schreine Exp $
// ----------------------------------------------------------------------------
