// ----------------------------------------------------------------------------
// $Id: Naturals.java,v 1.3 1999/06/28 14:32:38 schreine Exp $
// a subrange of the natural numbers
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class Naturals implements Domain
{
  int from;
  int to;

  public Naturals(int _from, int _to)
  {
    from = _from;
    to = _to;
  }

  public String getString()
  {
    return String.valueOf(from) + ".." + String.valueOf(to);
  }

  public boolean equals(int s, int t)
  {
    return from == s && to == t;
  }

  public boolean equals(Value v)
  {
    if (!(v instanceof Naturals)) return false;
    Naturals d = (Naturals)v;
    return d.equals(from, to);
  }

  public boolean hasElement(Value value)
  {
    if (!(value instanceof Nat)) return false;
    int i = ((Nat)value).intValue();
    return from <= i && i <= to;
  }

  private class NaturalsIterator implements Iterator
  {
    int next;
    
    public NaturalsIterator()
    {
      next = from;
    }

    public boolean hasNext()
    {
      return next <= to;
    }

    public Value next()
    {
      int result = next;
      next = next+1;
      return new Nat(result);
    }
  }

  public Iterator getIterator()
  {
    return new NaturalsIterator();
  }
}
// ----------------------------------------------------------------------------
// $Id: Naturals.java,v 1.3 1999/06/28 14:32:38 schreine Exp $
// ----------------------------------------------------------------------------
