// ----------------------------------------------------------------------------
// $Id: LessEqual.java,v 1.2 1999/06/29 10:05:26 schreine Exp $
// LessEqual two natural numbers
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Predicates;
import Logic.*;

public final class LessEqual implements Predicate
{
  public String name()
  {
    return "<=";
  }

  public int arity()
  {
    return 2;
  }

  public void check(Value value) throws EvalException
  {
    if (!(value instanceof Nat))
      throw new EvalException
	("value " + value.getString() + 
	 " in predicate <=/2 is not a natural number");
  }

  public boolean apply(Value[] arguments) throws EvalException
  {
    check(arguments[0]);
    check(arguments[1]);
    int n0 = ((Nat)arguments[0]).intValue();
    int n1 = ((Nat)arguments[1]).intValue();
    return n0 <= n1;
  }
}
// ----------------------------------------------------------------------------
// $Id: LessEqual.java,v 1.2 1999/06/29 10:05:26 schreine Exp $
// ----------------------------------------------------------------------------
