// ----------------------------------------------------------------------------
// $Id: Application.java,v 1.3 1999/06/28 14:38:53 schreine Exp $
// function application
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class Application implements Term
{
  private String name;
  private Term[] arguments;

  public Application(String _name, Term[] _arguments)
  {
    name = _name;
    arguments = _arguments;
  }

  public Value eval() throws EvalException
  {
    Function function = Model.getFunction(name, arguments.length);
    if (function == null)
      throw new EvalException("unknown function " + name + 
			      "/" + arguments.length);
    Value[] values = new Value[arguments.length];
    for (int i=0; i< values.length; i++)
      values[i] = arguments[i].eval();
    return function.apply(values);
  }  
}
// ----------------------------------------------------------------------------
// $Id: Application.java,v 1.3 1999/06/28 14:38:53 schreine Exp $
// ----------------------------------------------------------------------------
