// ----------------------------------------------------------------------------
// $Id: IfThenElseTerm.java,v 1.2 1999/06/28 14:08:38 schreine Exp $
// two-way conditional term
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class IfThenElseTerm implements Term
{
  private Formula formula;
  private Term term0;
  private Term term1;

  public IfThenElseTerm(Formula _formula, Term _term0, Term _term1)
  {
    formula = _formula;
    term0 = _term0;
    term1 = _term1;
  }

  public Value eval() throws EvalException
  {
    if (formula.eval())
      return term0.eval();
    else
      return term1.eval();
  }
}
// ----------------------------------------------------------------------------
// $Id: IfThenElseTerm.java,v 1.2 1999/06/28 14:08:38 schreine Exp $
// ----------------------------------------------------------------------------
