// ----------------------------------------------------------------------------
// $Id: IfThenTerm.java,v 1.3 1999/06/29 10:05:26 schreine Exp $
// one-way conditional term
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class IfThenTerm implements Term
{
  private Formula formula;
  private Term term;

  public IfThenTerm(Formula _formula, Term _term)
  {
    formula = _formula;
    term = _term;
  }

  public Value eval() throws EvalException
  {
    if (Model.checkGuard() && !formula.eval())
      throw new EvalException("guard condition is false");
    return term.eval();
  }
}
// ----------------------------------------------------------------------------
// $Id: IfThenTerm.java,v 1.3 1999/06/29 10:05:26 schreine Exp $
// ----------------------------------------------------------------------------
