// ----------------------------------------------------------------------------
// $Id: LetNTerm.java,v 1.4 1999/06/29 12:46:40 schreine Exp $
// term with n local variables
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class LetNTerm implements Term
{
  private BoundVariable[] variable;
  private Term term;

  public LetNTerm(BoundVariable[] _variable, Term _term)
  {
    variable = _variable;
    term = _term;
  }

  public Value eval() throws EvalException
  {
    for (int i=0; i<variable.length; i++)
      Context.begin(variable[i].name(), variable[i].value().eval());
    Value result = term.eval();
    for (int i=0; i<variable.length; i++)
      Context.end();
    return result;
  }  
}
// ----------------------------------------------------------------------------
// $Id: LetNTerm.java,v 1.4 1999/06/29 12:46:40 schreine Exp $
// ----------------------------------------------------------------------------
