// ----------------------------------------------------------------------------
// $Id: Reduce.java,v 1.3 1999/06/29 08:21:05 schreine Exp $
// reduction of a set by a binary function
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class Reduce implements Term
{
  private String name;
  private Term term;
  private Term base;

  public Reduce(String _name, Term _term, Term _base)
  {
    name = _name;
    term = _term;
    base = _base;
  }

  public Value eval() throws EvalException
  {
    Function function = Model.getFunction(name, 2);
    if (function == null)
      throw new EvalException("unknown function " + name + "/2");
    Value set = term.eval();
    if (!(set instanceof Domain))
      throw new EvalException("value " + set.getString() + 
			      " in function reduce/2 is not a set");
    Value result = base.eval();
    Iterator iterator = ((Domain)set).getIterator();
    while (iterator.hasNext())
      {
	Value[] arguments = new Value[2];
	arguments[0] = iterator.next();
	arguments[1] = result;
	result = function.apply(arguments);
      }
    return result;
  }
}
// ----------------------------------------------------------------------------
// $Id: Reduce.java,v 1.3 1999/06/29 08:21:05 schreine Exp $
// ----------------------------------------------------------------------------
