// ----------------------------------------------------------------------------
// $Id: Select.java,v 1.2 1999/06/28 14:08:38 schreine Exp $
// tuple selection
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class Select implements Term
{
  private Term term;
  private int field;

  public Select(Term _term, int _field)
  {
    term = _term;
    field = _field;
  }

  public Value eval() throws EvalException
  {
    Value value = term.eval();
    if (!(value instanceof Tuple))
      throw new EvalException("value " + value.getString() + 
			      " in field selection is not a tuple");
    Tuple tuple = (Tuple)value;
    int n = tuple.length();
    if (n <= field) 
      throw new EvalException("field number " + field + 
			      " selected but tuple has only " + n + 
			      " fields (numbered from 0)");
    return tuple.elementAt(field);
  }
}
// ----------------------------------------------------------------------------
// $Id: Select.java,v 1.2 1999/06/28 14:08:38 schreine Exp $
// ----------------------------------------------------------------------------
