// ----------------------------------------------------------------------------
// $Id: SetNTerm.java,v 1.7 1999/07/12 12:17:36 schreine Exp $
// set constructor with n variables
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class SetNTerm implements Term
{
  private IteratorVariable[] variables;
  private Formula formula;
  private Term term;

  public SetNTerm(IteratorVariable[] _variables, Formula _formula, Term _term)
  {
    variables = _variables;
    formula = _formula;
    term = _term;
  }

  public void eval(int i, Set set) throws EvalException
  {
    if (i == variables.length)
      {
	if (formula.eval())
	  set.addElement(term.eval());
	return;
      }
    Iterator iterator = variables[i].iterator(); 
    while (iterator.hasNext())
      {
	Context.begin(variables[i].name(), iterator.next());
	eval(i+1, set);
	Context.end();
      }
  }

  public Value eval() throws EvalException
  {
    Set set = new Set();
    eval(0, set);
    return set;
  }
}
// ----------------------------------------------------------------------------
// $Id: SetNTerm.java,v 1.7 1999/07/12 12:17:36 schreine Exp $
// ----------------------------------------------------------------------------
