// ----------------------------------------------------------------------------
// $Id: SetTerm.java,v 1.5 1999/07/12 08:32:11 schreine Exp $
// set constructor with one variable
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class SetTerm implements Term
{
  private String variable;
  private Term domain;
  private Formula formula;
  private Term element;

  public SetTerm(String _variable, Term _domain, 
		 Formula _formula, Term _element)
  {
    variable = _variable;
    domain = _domain;
    formula = _formula;
    element = _element;
  }

  public Value eval() throws EvalException
  {
    Set set = new Set();
    Iterator iterator = Model.iterator(domain);
    while (iterator.hasNext())
    {
      Context.begin(variable, iterator.next());
      if (formula.eval()) 
	set.addElement(element.eval());
      Context.end();
    }
    return set;
  }
}
// ----------------------------------------------------------------------------
// $Id: SetTerm.java,v 1.5 1999/07/12 08:32:11 schreine Exp $
// ----------------------------------------------------------------------------
