// ----------------------------------------------------------------------------
// $Id: SuchThat.java,v 1.5 1999/07/12 12:17:36 schreine Exp $
// implicit definition of a value
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class SuchThat implements Term
{
  private IteratorVariable[] variables;
  private Formula formula;
  private Term term;

  public SuchThat(IteratorVariable[] _variables, Formula _formula, Term _term)
  {
    variables = _variables;
    formula = _formula;
    term = _term;
  }

  public Value eval(int i) throws EvalException
  {
    if (i == variables.length)
      {
	if (formula.eval())
	  return term.eval();
	return null;
      }
    Iterator iterator = variables[i].iterator(); 
    while (iterator.hasNext())
      {
	Context.begin(variables[i].name(), iterator.next());
	Value value = eval(i+1);
	Context.end();
	if (value != null) return value;
      }
    return null;
  }

  public Value eval() throws EvalException
  {
    Value value = eval(0);
    if (value == null)
      throw new EvalException("no such value");
    return value;
  }
}
// ----------------------------------------------------------------------------
// $Id: SuchThat.java,v 1.5 1999/07/12 12:17:36 schreine Exp $
// ----------------------------------------------------------------------------
