// ----------------------------------------------------------------------------
// $Id: TupleTerm.java,v 1.2 1999/06/28 14:08:38 schreine Exp $
// tuple term
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic.Terms;
import Logic.*;

public final class TupleTerm implements Term
{
  private Term[] terms;

  public TupleTerm(Term[] _terms)
  {
    terms = _terms;
  }

  public Value eval() throws EvalException
  {
    int n = terms.length;
    Value[] values = new Value[n];
    for (int i=0; i<n; i++)
      values[i] = terms[i].eval();
    return new Tuple(values);
  }
}
// ----------------------------------------------------------------------------
// $Id: TupleTerm.java,v 1.2 1999/06/28 14:08:38 schreine Exp $
// ----------------------------------------------------------------------------
