// ----------------------------------------------------------------------------
// $Id: Tuple.java,v 1.2 1999/06/28 14:32:38 schreine Exp $
// a tuple value
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class Tuple implements Value
{
  private Value[] elems;

  public Tuple(Value[] _elems)
  {
    elems = _elems;
  }

  public String getString()
  {
    StringBuffer s = new StringBuffer();
    s.append("<");
    int n = elems.length;
    for (int i=0; i<n; i++)
      {
	s.append(elems[i].getString());
	if (i < n-1) s.append(", ");
      }
    s.append(">");
    return s.toString();
  }

  public boolean equals(Value v)
  {
    if (!(v instanceof Tuple)) return false;
    Value[] elems0 = ((Tuple)v).elems;
    int n = elems.length;
    if (n != elems0.length) return false;
    for (int i=0; i<n; i++)
      {
	if (!elems[i].equals(elems0[i])) 
	  return false;
      }
    return true;
  }

  public int length()
  {
    return elems.length;
  }

  public Value elementAt(int i)
  {
    return elems[i];
  }
}
// ----------------------------------------------------------------------------
// $Id: Tuple.java,v 1.2 1999/06/28 14:32:38 schreine Exp $
// ----------------------------------------------------------------------------
