// ----------------------------------------------------------------------------
// $Id: ValueVariable.java,v 1.1 1999/07/12 12:17:36 schreine Exp $
// a pair of a variable and a term (denoting a value)
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class ValueVariable implements IteratorVariable
{
  private String string;
  private Term term;

  public ValueVariable(String _string, Term _term)
  {
    string = _string;
    term = _term;
  }

  public String name()
  {
    return string;
  }

  private class ValueIterator implements Iterator
  {
    private Value value;

    public ValueIterator(Value _value)
    {
      value = _value;
    }

    public boolean hasNext()
    {
      return value != null;
    }

    public Value next()
    {
      Value v = value;
      value = null;
      return v;
    }
  }

  // --------------------------------------------------------------------------
  // returns a single value iterator
  // --------------------------------------------------------------------------
  public Iterator iterator() throws EvalException
  {
    return new ValueIterator(term.eval());
  }
}
// ----------------------------------------------------------------------------
// $Id: ValueVariable.java,v 1.1 1999/07/12 12:17:36 schreine Exp $
// ----------------------------------------------------------------------------
