// ----------------------------------------------------------------------------
// $Id: Variable.java,v 1.3 1999/07/12 12:17:36 schreine Exp $
// a variable
//
// (c) 1999, Wolfgang Schreiner, see file COPYRIGHT
// http://www.risc.uni-linz.ac.at/software/formal
// ----------------------------------------------------------------------------
package Logic;

public final class Variable implements 
  Term, IteratorVariable, ConstrainedVariable
{
  private String variable;

  public Variable(String _variable)
  {
    variable = _variable;
  }

  public String name()
  {
    return variable;
  }

  // --------------------------------------------------------------------------
  // evaluates to a value
  // --------------------------------------------------------------------------
  public Value eval() throws EvalException
  {
    Value value = Context.get(variable);
    if (value == null)
      throw new EvalException("no variable " + variable + " in context");
    return value;
  }

  // --------------------------------------------------------------------------
  // returns an iterator for the universe
  // --------------------------------------------------------------------------
  public Iterator iterator() throws EvalException
  {
    Domain domain = Model.getDomain();
    if (domain == null)
      throw new EvalException("no universe of discourse specified");
    return domain.getIterator();
  }

  // --------------------------------------------------------------------------
  // throws exception if value does not match variable constraints
  // --------------------------------------------------------------------------
  public void check(Value value) throws EvalException
  {
  }
}
// ----------------------------------------------------------------------------
// $Id: Variable.java,v 1.3 1999/07/12 12:17:36 schreine Exp $
// ----------------------------------------------------------------------------
